import {Command} from 'ckeditor5/src/core';
import {  getClosestSelectedSpanElement  } from "./utils"; 
//import { first } from 'ckeditor5/src/utils';


//import { DocumentFragment, Element, Position, Range, Schema, Writer } from 'ckeditor5/src/engine';

export default class SpanRemoveCommand extends Command {
  constructor( editor, attributeKey ) {
		super( editor );
		this.attributeKey = attributeKey;
	}

  execute(settings) {
    const model = this.editor.model;
    //const schema = model.schema;
    const selection = model.document.selection;
    const existingSpan = getClosestSelectedSpanElement(selection);
    if(!settings) settings = {}; 

    //const selectedElement = selection.getSelectedElement();   
      
    model.change((writer) => {

      
      const blocks = Array.from( selection.getSelectedBlocks() );
      
/*
      // Unquote all groups of block. Iterate in the reverse order to not break following ranges.
		  this.getRangesOfBlockGroups( writer, blocks.filter( this.findQuote ) ).reverse().forEach( groupRange => {
        if ( groupRange.start.isAtStart && groupRange.end.isAtEnd ) {
          writer.unwrap( groupRange.start.parent  );
          return;
        }
        console.log('execute removeSpan' );
        // The group of blocks are at the beginning of an <bQ> so let's move them left (out of the <bQ>).
        if ( groupRange.start.isAtStart ) {
          const positionBefore = writer.createPositionBefore( groupRange.start.parent  );
          writer.move( groupRange, positionBefore );
          return;
        }

        // The blocks are in the middle of an <bQ> so we need to split the <bQ> after the last block
        // so we move the items there.
        if ( !groupRange.end.isAtEnd ) {
          writer.split( groupRange.end );
        }

        // Now we are sure that groupRange.end.isAtEnd is true, so let's move the blocks right.
        const positionAfter = writer.createPositionAfter( groupRange.end.parent  );
        writer.move( groupRange, positionAfter );
      } );
*/
			// Get ranges to unlink.
			/*const rangesToUnlink = selection.isCollapsed ?
				[ findAttributeRange(
					selection.getFirstPosition()!,
					'linkHref',
					selection.getAttribute( 'linkHref' ),
					model
				) ] :
				model.schema.getValidRanges( selection.getRanges(), 'linkHref' );*/
      /*const rangesToUnlink = model.schema.getValidRanges( selection.getRanges(), 'span' );
      console.log('remove ', rangesToUnlink, selection.getRanges())
			// Remove `linkHref` attribute from specified ranges.
			for ( const range of rangesToUnlink ) {
        console.log('iiiiiiii')
			}*/
      //writer.remove(existingSpan);


      if(existingSpan)
      { 
        //const startOffset = existingSpan.startOffset;

        writer.remove(existingSpan);
        const currentAttributes = selection.getAttributes();
        const insertPosition = selection.focus;

        //for ( const child of existingSpan.getChildren() ) {
        //const children = existingSpan.getChildren();
        //for (let i = children.length - 1; i >= 0 ; i--) {
        //  const child = children[i];
        //   const data = child.data;
        //  writer.insertText( data, currentAttributes, insertPosition );
        //}
        
        var child = existingSpan.getChild(0);
        if(child){
          const data = child.data;
          writer.insertText( data, currentAttributes, insertPosition );
        }
      }
        


    });
  }

    findQuote( elementOrPosition ) {
      return elementOrPosition.parent.name == 'span' ? elementOrPosition.parent : null;
    }
   getRangesOfBlockGroups( writer, blocks) {
    let startPosition;
    let i = 0;
    const ranges = [];
  
    while ( i < blocks.length ) {
      const block = blocks[ i ];
      const nextBlock = blocks[ i + 1 ];
  
      if ( !startPosition ) {
        startPosition = writer.createPositionBefore( block );
      }
  
      if ( !nextBlock || block.nextSibling != nextBlock ) {
        ranges.push( writer.createRange( startPosition, writer.createPositionAfter( block ) ) );
        startPosition = null;
      }
  
      i++;
    }
  
    return ranges;
  }

}

